
%%% Insert sort

order([],[]).
order([H|T],R):-
     order(T,TR),
     put(H,TR,R).
        
put(H,[],[H]):-!.
put(H,[X|Y],[H,X|Y]):-
        H < X,!.
put(H,[X|Y],[X|Z]):-
        put(H,Y,Z). 


%%% Sorting by finding minimal/maximal element

min([X],X):-!.
min([P|R],P):- min(R,X),X > P,!.
min([P|R],X):- min(R,X),X =< P.

max([X],X):-!.
max([P|R],P):- max(R,X),X =< P,!.
max([P|R],X):- max(R,X),X > P.

min-sort([],[]):- !.
min-sort(L,[M|LS]):- 
   min(L,M),
   select(M,L,LM),
   min-sort(LM,LS).

min-sort-iter(L,LS):- msi(L,[],LS).

msi([],LS,LS):- !.
msi(L,LA,LS):- 
   max(L,M),
   select(M,L,LM),!,
   msi(LM,[M|LA],LS).

%% Iterativ minimal element

    mini([X|T],MIN,MINI):-
       X<MIN,!,
       mini(T,X,MINI).
    mini([_|T],MIN,MINI):-
       mini(T,MIN,MINI).
    mini([],MINI,MINI).

%%% list split equal: lse/6
%%% lse(L,L1,L2,W1,W2,l/p).


lse([],W1,W2,W1,W2,_):- !.
lse([H|T],L1,L2,W1,W2,l):- lse(T,[H|L1],L2,W1,W2,p), !.
lse([H|T],L1,L2,W1,W2,p):- lse(T,L1,[H|L2],W1,W2,l), !.

split-lse([],[],[]).
split-lse([H|T],[H|U],V):- split-lse(T,V,U).

merge([H1|T1],[H2|T2],[H1|T]):-
   H1 < H2, !,
   merge(T1,[H2|T2],T).
merge([H1|T1],[H2|T2],[H2|T]):-
   merge([H1|T1],T2,T),!.
merge(X,[],X):-!.
merge([],X,X).

mergesort([],[]):- !.
mergesort([H],[H]):- !.
mergesort(L,S):-
   split-lse(L,LL,LR),
   mergesort(LL,SLL),
   mergesort(LR,SLR),
   merge(SLL,SLR,S).

qsort([],[]).
qsort([H|T],S):-
	split(H,T,L,R),
	qsort(L,LS),
	qsort(R,RS),
	append(LS,[H|RS],S).

split(_,[],[],[]).
split(H,[A|X],[A|Y],Z):-
	A =< H,
	!,
	split(H,X,Y,Z).
split(H,[A|X],Y,[A|Z]):-
	A > H,
	!,
	split(H,X,Y,Z).


