% Take the N-th element of a list.

take(1,[H|_],H):- !.
take(N,[_|T],X):- N1 is N-1, take(N1,T,X).

len([],0).
len([_|T],L):- 
   len(T,LT),
   L is LT+1.

sum([],0).
sum([H|T],S):- 
   sum(T,ST),
   S is ST+H.

writelist([]):- nl.
writelist([H|T]):-
       write(H),nl,
       writelist(T).

sublist(S,FSL,F,L):- append(F,SL,FSL),append(S,L,SL).

subseq([],_):- !.
subseq([H|S],L):- append(_,[H|SL],L),!, subseq(S,SL).

putk(X,1,L,[X|L]):- !.
putk(X,K,[F|L],[F|LX]):- K1 is K-1, putk(X,K1,L,LX). 

del(X,[X|L],L).
del(X,[Y|L],[Y|L1]):-
       del(X,L,L1).

delall(_,[],[]):- !.
delall(X,[H|L],[H|LL]):- X \= H,!, delall(X,L,LL).
delall(X,[X|L],LL):- delall(X,L,LL).

insert(X,L,LX):-
       del(X,LX,L).  

perm([],[]).
perm([H|T],P):-
   perm(T,T1),
   insert(H,T1,P).




permutation([],[]).
permutation([G|Ogon],Wynik):-
		permutation(Ogon,W1),
		insert(G,W1,Wynik).

inserta(Y,XZ,XYZ):- append(X,Z,XZ),append(X,[Y|Z],XYZ).



sorted([]):- !.
sorted([_]):- !.
sorted([X,Y|T]) :- X =< Y, sorted([Y|T]).

nsort(L,S):-
	perm(L,S),
	sorted(S).

slowsort(L,S):-
	perm(L,S),
	sorted(S),!.

reverse([],[]).
reverse([X|L],R):-
       reverse(L,RL),
       append(RL,[X],R).

inverse(L,R):-
       do([],L,R).
    do(L,[],L):-!.
    do(L,[X|T],S):- 
       write(L),write('   '),write([X|T]),nl,
       do([X|L],T,S).






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   

dlugosc([],0).
dlugosc([_|T],D):- 
   dlugosc(T,DT),
   D is DT+1.
   
sumalisty([],0).
sumalisty([H|T],S):- 
   sumalisty(T,ST),
   S is ST+H.

wstaw(X,[],[X]):- !.
wstaw(X,L,[X|L]).
wstaw(X,[P|L],[P|LX]):- wstaw(X,L,LX).
   
