%%% listy: przykłady najprostszych operacji

% Czy element H nalezy do listy
member(H,[H|_]) :- !.
member(H,[_|T]) :- write('***'),nl,member(H,T).

% Niedeterministyczny wybór elementu z listy
choose(H,[H|_]).
choose(H,[_|T]) :- choose(H,T).

sel(H,[H|T],T).
sel(X,[H|T],[H|TX]):- sel(X,T,TX).

% Jak wyżej, zwracana jest też lista pozostałych (pred. stand.)
select(H,[H|T],T).
select(H,[E|T],[E|TH]) :- select(H,T,TH).

% append; klasyka (pred. stand.)
append([],L,L).
append([H|T],L,[H|TL]) :- append(T,L,TL).

% podlista
sublist(S,L,Front,End,Rest) :-
	append(Front,End,L), % Rozbiór L na Front i End
	append(S,Rest,End).
	

% Długość listy [predykat standardowy length(<lista>,<dlugosc>)]
len([],0).
len([_|T],N) :-
	len(T,NT),
	N is NT + 1.


% Odwracanie kolejnści

% reverse: klasyka, rekurencja

nreverse1([],[]).
nreverse1([H|T],RH) :-
	nreverse1(T,R),
	append(R,[H],RH).

% Poprawne rozwiązanie: iteracje z akumulatorem
inverse(L,R) :- do(L,[],R).

do([],R,R). % Koniec lista jest pusta to wynik = akumulator
do([H|T],A,R) :- do(T,[H|A],R). % Prze³adowanie kolejnego elementu H z listy do akumulatora.


% Cwiczenia:
% 1. Wstawianie do listy
% 2. Wstawianie na koniec listy
% eof

un([],S,S).
un([E|P],S,T):-
	 member(E,S),!,
	 un(P,S,T).
un([E|P],S,[E|T]):-
	\+ member(E,S),!,
	 un(P,S,T).


inslast(X,[],[X]):-!.
inslast(X,[H|T],[H|TX]):- inslast(X,T,TX).

inslastapp(X,L,LX):- append(L,[X],LX).

