% Lists: simple tricks
% exchange first-last

exfl_base(FSL,R):- take_first(FSL,F,SL), 
                   take_last(SL,L,S),
                   put_last(S,F,SF),
                   put_first(SF,L,LSF),
                   R = LSF.

take_first(FS,F,S):- FS=[F|S].

take_last(SL,L,S):-  SL=[L],S=[],!.
take_last(SL,L,S):-  SL=[H|T],take_last(T,L,TL),S=[H|TL].

put_first(S,F,FS):-  FS=[F|S].

put_last(S,L,SL):- S=[],SL=[L],!.
put_last(S,L,SL):- S=[H|T], put_last(T,L,TL),SL=[H|TL].

% smart exft
exfl([F|TL],[L|SF]):- append(S,[L],TL), append(S,[F],SF).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% get elements of a list: 3,4,7

g347([_,_,X,Y,_,_,Z|_]).

% get and remowe:

g347([A,B,X,Y,C,D,Z|T],[A,B,C,D|T]).


% get elements from back:


% get and remowe from back:





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% shift left/right circular

shftl_base(FS,SF):- take_first(FS,F,S),
                    put_last(S,F,SF).

% smart shftl
shftl([F|T],TF):- append(T,[F],TF).

% shift right circular

shftr_base(SL,LS):- take_last(SL,L,S),
                    put_first(S,L,LS).

% smart shftr
shftr(SL,[L|S]):- append(S,[L],SL).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% subsequences

subseq3c(FXYZL,[X,Y,Z],F,L):- append(F,[X,Y,Z|L],FXYZL).

subseq3d(FXAYBZL,[X,Y,Z],F,A,B,L):- append(F,[X|AYBZL],FXAYBZL), append(A,[Y|BZL],AYBZL), append(B,[Z|L],BZL).

sublist(S,FSL,F,L):- append(F,SL,FSL),append(S,L,SL).

subseq([],_).
subseq([H|S],L):- append(_,[H|SL],L), subseq(S,SL).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% collect facts

:- dynamic(p/1).
:- dynamic(list/1).
:- assert(list([])).
p(1).
p(2).
p(3).
p(4).
p(5).


collect(_):- 
             p(X),
             retract(list(T)),
             assert(list([X|T])),
             fail.
collect(L):- list(L).

% coolecti - iterative with retract
collecti(L):- collect_iter([],L).

collect_iter(T,L):- retract(p(X)), !,
                    collect_iter([X|T],L).
collect_iter(L,L).




